From c3490bbae8ba96f937ebd93d17155d8ad0766b48 Mon Sep 17 00:00:00 2001
From: Walter Doekes <walter+github@wjd.nu>
Date: Sun, 20 Sep 2015 13:47:50 +0200
Subject: [PATCH 15/15] Clean up format_cap_set stuff. Possibly fixing Local
 channel support.

---
 chan_dongle.c |  1 -
 chan_dongle.h |  1 -
 channel.c     | 26 +++++++++++++++++---------
 3 files changed, 17 insertions(+), 11 deletions(-)

diff --git a/chan_dongle.c b/chan_dongle.c
index 01d17f7..ff87e32 100644
--- a/chan_dongle.c
+++ b/chan_dongle.c
@@ -1662,7 +1662,6 @@ static int public_state_init(struct public_state * state)
 				return AST_MODULE_LOAD_FAILURE;
 			}
 			ast_format_cap_append(channel_tech.capabilities, ast_format_slin, 0);
-			//chan_dongle_format_cap = channel_tech.capabilities;
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 			ast_format_set(&chan_dongle_format, AST_FORMAT_SLINEAR, 0);
 			if (!(channel_tech.capabilities = ast_format_cap_alloc())) {
diff --git a/chan_dongle.h b/chan_dongle.h
index b6e0436..362cffc 100644
--- a/chan_dongle.h
+++ b/chan_dongle.h
@@ -41,7 +41,6 @@ INLINE_DECL const char * dev_state2str_msg(dev_state_t state)
 #if ASTERISK_VERSION_NUM >= 100000 && ASTERISK_VERSION_NUM < 130000 /* 10-13 */
 /* Only linear is allowed */
 EXPORT_DECL struct ast_format chan_dongle_format;
-//EXPORT_DEF struct ast_format chan_dongle_format;
 EXPORT_DECL struct ast_format_cap * chan_dongle_format_cap;
 #endif /* ^10-13 */
 
diff --git a/channel.c b/channel.c
index 40dd629..e5dd43c 100644
--- a/channel.c
+++ b/channel.c
@@ -679,7 +679,7 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 
 		cpvt->a_read_frame.frametype = AST_FRAME_VOICE;
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-		cpvt->a_read_frame.subclass.format = ao2_bump(ast_format_slin);
+		cpvt->a_read_frame.subclass.format = ast_format_slin;
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 		ast_format_copy(&cpvt->a_read_frame.subclass.format, &chan_dongle_format);
 #else /* 10- */
@@ -1265,21 +1265,29 @@ EXPORT_DEF struct ast_channel* new_channel(
 			ast_channel_tech_set(channel, &channel_tech);
 
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-			ast_format_cap_append(ast_channel_nativeformats(channel), ast_format_slin, 0);
+			ast_channel_nativeformats_set(channel, channel_tech.capabilities);
+			ast_channel_set_rawreadformat(channel, ast_format_slin);
+			ast_channel_set_rawwriteformat(channel, ast_format_slin);
 			ast_channel_set_writeformat(channel, ast_format_slin);
 			ast_channel_set_readformat(channel, ast_format_slin);
 #elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
-			ast_format_set(ast_channel_readformat(channel), AST_FORMAT_SLINEAR, 0);
-			ast_format_set(ast_channel_writeformat(channel), AST_FORMAT_SLINEAR, 0);
-			ast_format_cap_set(ast_channel_nativeformats(channel), ast_channel_writeformat(channel));
+		        ast_format_cap_add(ast_channel_nativeformats(channel), &chan_dongle_format);
+		        ast_format_copy(ast_channel_rawreadformat(channel), &chan_dongle_format);
+		        ast_format_copy(ast_channel_rawwriteformat(channel), &chan_dongle_format);
+		        ast_format_copy(ast_channel_writeformat(channel), &chan_dongle_format);
+		        ast_format_copy(ast_channel_readformat(channel), &chan_dongle_format);
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-			ast_format_set(&channel->readformat, AST_FORMAT_SLINEAR, 0);
-			ast_format_set(&channel->writeformat, AST_FORMAT_SLINEAR, 0);
-			ast_format_cap_set(channel->nativeformats, &channel->writeformat);
+		        ast_format_cap_add(channel->nativeformats, &chan_dongle_format);
+		        ast_format_copy(&channel->rawreadformat, &chan_dongle_format);
+		        ast_format_copy(&channel->rawwriteformat, &chan_dongle_format);
+		        ast_format_copy(&channel->writeformat, &chan_dongle_format);
+		        ast_format_copy(&channel->readformat, &chan_dongle_format);
 #else /* 10- */
 			channel->nativeformats	= AST_FORMAT_SLINEAR;
-			channel->writeformat	= AST_FORMAT_SLINEAR;
+			channel->rawreadformat	= AST_FORMAT_SLINEAR;
+			channel->rawwriteformat	= AST_FORMAT_SLINEAR;
 			channel->readformat	= AST_FORMAT_SLINEAR;
+			channel->writeformat	= AST_FORMAT_SLINEAR;
 #endif /* ^10- */
 
 			if (ast_state == AST_STATE_RING)
